Index: LMDZ5/trunk/libf/phylmd/cosp/optics_lib.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/optics_lib.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/optics_lib.F90	(revision 2428)
@@ -1,2 +1,4 @@
+! $Revision: 88 $, $Date: 2013-11-13 15:08:38 +0100 (mer. 13 nov. 2013) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/quickbeam/optics_lib.f90 $
 ! OPTICS_LIB: Optical proecures for for F90
 ! Compiled/Modified:
@@ -15,5 +17,5 @@
 ! subroutine M_WAT
 ! ----------------------------------------------------------------------------
-  subroutine m_wat(freq, t, n_r, n_i)
+  subroutine m_wat(freq, tk, n_r, n_i)
   implicit none
 !  
@@ -23,5 +25,5 @@
 ! Inputs:
 !   [freq]    frequency (GHz)
-!   [t]       temperature (C)
+!   [tk]       temperature (K)
 !
 ! Outputs:
@@ -36,5 +38,5 @@
   
 ! ----- INPUTS -----
-  real*8, intent(in) :: freq,t
+  real*8, intent(in) :: freq,tk
   
 ! ----- OUTPUTS -----
@@ -45,12 +47,15 @@
   real*8 e_r,e_i
   real*8 pi
+  real*8 tc
   complex*16 e_comp, sq
 
+  tc = tk - 273.15
+
   ld = 100.*2.99792458E8/(freq*1E9)
-  es = 78.54*(1-(4.579E-3*(t-25.)+1.19E-5*(t-25.)**2 &
-       -2.8E-8*(t-25.)**3))
-  ei = 5.27137+0.021647*t-0.00131198*t**2
-  a = -(16.8129/(t+273.))+0.0609265
-  ls = 0.00033836*exp(2513.98/(t+273.))
+  es = 78.54*(1-(4.579E-3*(tc-25.)+1.19E-5*(tc-25.)**2 &
+       -2.8E-8*(tc-25.)**3))
+  ei = 5.27137+0.021647*tc-0.00131198*tc**2
+  a = -(16.8129/(tc+273.))+0.0609265
+  ls = 0.00033836*exp(2513.98/(tc+273.))
   sg = 12.5664E8
 
@@ -84,5 +89,5 @@
 ! Inputs:
 !   [freq]    frequency (GHz)
-!   [t]       temperature (C)
+!   [t]       temperature (K)
 !
 ! Outputs:
@@ -106,6 +111,6 @@
   parameter(nwl=468,nwlt=62)
 
-  real*8 :: alam,cutice,pi,t1,t2,tk,wlmax,wlmin, &
-            x,x1,x2,y,y1,y2,ylo,yhi
+  real*8 :: alam,cutice,pi,t1,t2,wlmax,wlmin, &
+            x,x1,x2,y,y1,y2,ylo,yhi,tk
 
   real*8 :: &
@@ -502,4 +507,6 @@
   n_i=0.0
 
+  tk = t
+
 ! // convert frequency to wavelength (um)
   alam=3E5/freq
@@ -508,7 +515,4 @@
     stop
   endif
-
-! // convert temperature to K
-  tk = t + 273.16
 
   if (alam < cutice) then
@@ -706,5 +710,5 @@
          Dqsc = Tnp1 * (A*Conjg(A) + B*Conjg(B)) + Dqsc
          If (N.Gt.1) then
-	    Dg = Dg + (dN*dN - 1) * Dble(ANM1*Conjg(A) + BNM1 * Conjg(B)) / dN + TNM1 * Dble(ANM1*Conjg(BNM1)) / (dN*dN - dN)
+         Dg = Dg + (dN*dN - 1) * Dble(ANM1*Conjg(A) + BNM1 * Conjg(B)) / dN + TNM1 * Dble(ANM1*Conjg(BNM1)) / (dN*dN - dN)
          End If
          Anm1 = A
Index: LMDZ5/trunk/libf/phylmd/cosp/pf_to_mr.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/pf_to_mr.F	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/pf_to_mr.F	(revision 2428)
@@ -1,4 +1,6 @@
 ! (c) 2008, Lawrence Livermore National Security Limited Liability Corporation.
 ! All rights reserved.
+! $Revision: 23 $, $Date: 2011-03-31 15:41:37 +0200 (jeu. 31 mars 2011) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/llnl/pf_to_mr.f $
 ! 
 ! Redistribution and use in source and binary forms, with or without modification, are permitted 
@@ -35,9 +37,9 @@
       INTEGER ncol          !  number of subcolumns
 
-      INTEGER i,j,ilev,ibox
+      INTEGER j,ilev,ibox
       
-      REAL rain_ls(npoints,nlev),snow_ls(npoints,nlev) ! large-scale precipitation flux
+      REAL rain_ls(npoints,nlev),snow_ls(npoints,nlev) ! large-scale precip. flux
       REAL grpl_ls(npoints,nlev)
-      REAL rain_cv(npoints,nlev),snow_cv(npoints,nlev) ! convective precipitation flux
+      REAL rain_cv(npoints,nlev),snow_cv(npoints,nlev) ! convective precip. flux
 
       REAL prec_frac(npoints,ncol,nlev) ! 0 -> clear sky
@@ -54,5 +56,5 @@
       REAL term1x2r,term1x2s,term1x2g,t123r,t123s,t123g
       
-      ! method from Khairoutdinov and Randall (2003 JAS)		
+      ! method from Khairoutdinov and Randall (2003 JAS)
 
       ! --- List of constants from Appendix B
Index: LMDZ5/trunk/libf/phylmd/cosp/phys_cosp.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/phys_cosp.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/phys_cosp.F90	(revision 2428)
@@ -2,5 +2,6 @@
 
 ! ISCCP, Radar (QuickBeam), Lidar et Parasol (ACTSIM), MISR, RTTOVS
-!Idelkadi Abderrahmane Aout-Septembre 2009
+!Idelkadi Abderrahmane Aout-Septembre 2009 First Version
+!Idelkadi Abderrahmane Nov 2015 version v1.4.0
 
   subroutine phys_cosp( itap,dtime,freq_cosp, &
@@ -67,6 +68,10 @@
 ! meantbisccp,                          !Mean all-sky 10.5 micron brightness temperature as calculated by the ISCCP Simulator
 ! meantbclrisccp                        !Mean clear-sky 10.5 micron brightness temperature as calculated by the ISCCP Simulator
+
+!!! AI rajouter les nouvelles sorties
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
+!! AI rajouter
+  #include "cosp_defs.h" 
   USE MOD_COSP_CONSTANTS
   USE MOD_COSP_TYPES
@@ -78,5 +83,6 @@
   use cosp_output_mod
   use cosp_output_write_mod
- 
+!  use MOD_COSP_Modis_Simulator, only : cosp_modis 
+
   IMPLICIT NONE
 
@@ -100,5 +106,11 @@
   type(cosp_sglidar) :: sglidar ! Output from lidar simulator
   type(cosp_isccp)   :: isccp   ! Output from ISCCP simulator
+!! AI rajout modis
+  type(cosp_modis)   :: modis   ! Output from MODIS simulator
+!!
   type(cosp_misr)    :: misr    ! Output from MISR simulator
+!! AI rajout rttovs
+!  type(cosp_rttov)   :: rttov   ! Output from RTTOV
+!!
   type(cosp_vgrid)   :: vgrid   ! Information on vertical grid of stats
   type(cosp_radarstats) :: stradar ! Summary statistics from radar simulator
@@ -106,5 +118,5 @@
 
   integer :: t0,t1,count_rate,count_max
-  integer :: Nlon,Nlat,geomode
+  integer :: Nlon,Nlat
   real,save :: radar_freq,k2,ZenAng,co2,ch4,n2o,co,emsfc_lw
 !$OMP THREADPRIVATE(emsfc_lw)
@@ -134,6 +146,6 @@
   integer                         :: itap,k,ip
   real                            :: dtime,freq_cosp
+  real,dimension(2)               :: time_bnds
   
-!
    namelist/COSP_INPUT/overlap,isccp_topheight,isccp_topheight_direction, &
               npoints_it,ncolumns,use_vgrid,nlr,csat_vgrid, &
@@ -167,8 +179,11 @@
 
   print*,' Cles des differents simulateurs cosp :'
-  print*,' Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lrttov_sim', &
-          cfg%Lradar_sim,cfg%Llidar_sim,cfg%Lisccp_sim,cfg%Lmisr_sim,cfg%Lrttov_sim
+  print*,'Lradar_sim,Llidar_sim,Lisccp_sim,Lmisr_sim,Lmodis_sim,Lrttov_sim', &
+          cfg%Lradar_sim,cfg%Llidar_sim,cfg%Lisccp_sim,cfg%Lmisr_sim,cfg%Lmodis_sim,cfg%Lrttov_sim
 
   endif ! debut_cosp
+
+  time_bnds(1) = dtime-dtime/2.
+  time_bnds(2) = dtime+dtime/2.
 
 !  print*,'Debut phys_cosp itap,dtime,freq_cosp,ecrit_mth,ecrit_day,ecrit_hf ', &
@@ -178,6 +193,16 @@
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         print *, 'Allocating memory for gridbox type...'
-
-        call construct_cosp_gridbox(dble(itap),radar_freq,surface_radar,use_mie_tables,use_gas_abs,do_ray,melt_lay,k2, &
+!! AI
+!        call construct_cosp_gridbox(dble(itap),radar_freq,surface_radar,use_mie_tables,use_gas_abs,do_ray,melt_lay,k2, &
+!                                    Npoints,Nlevels,Ncolumns,N_HYDRO,Nprmts_max_hydro,Naero,Nprmts_max_aero,Npoints_it, &
+!                                    lidar_ice_type,isccp_topheight,isccp_topheight_direction,overlap,emsfc_lw, &
+!                                    use_precipitation_fluxes,use_reff, &
+!                                    Platform,Satellite,Instrument,Nchannels,ZenAng, &
+!                                    channels(1:Nchannels),surfem(1:Nchannels),co2,ch4,n2o,co,gbx)
+! Surafce emissivity
+        emsfc_lw = 1.
+
+        call construct_cosp_gridbox(dtime,time_bnds,radar_freq,surface_radar,use_mie_tables,use_gas_abs, &
+                                    do_ray,melt_lay,k2, &
                                     Npoints,Nlevels,Ncolumns,N_HYDRO,Nprmts_max_hydro,Naero,Nprmts_max_aero,Npoints_it, &
                                     lidar_ice_type,isccp_topheight,isccp_topheight_direction,overlap,emsfc_lw, &
@@ -230,11 +255,12 @@
 
 ! sunlit calcule a partir de la fraction d ensoleillement par jour
-      do ip = 1, Npoints
-        if (sunlit(ip).le.0.) then
-           gbx%sunlit(ip)=0.
-        else
-           gbx%sunlit(ip)=1.
-        endif
-      enddo
+!      do ip = 1, Npoints
+!        if (sunlit(ip).le.0.) then
+!           gbx%sunlit(ip)=0.
+!        else
+!           gbx%sunlit(ip)=1.
+!        endif
+!      enddo
+       gbx%sunlit=sunlit
 
 ! A voir l equivalent LMDZ
@@ -260,4 +286,5 @@
      gbx%Reff(:,:,I_LSCLIQ) = ref_liq*1e-6
      gbx%Reff(:,:,I_LSCICE) = ref_ice*1e-6
+!! AI A revoir
      gbx%Reff(:,:,I_CVCLIQ) = ref_liq*1e-6
      gbx%Reff(:,:,I_CVCICE) = ref_ice*1e-6
@@ -269,7 +296,4 @@
         gbx%dem_c    = 0.
 
-! Surafce emissivity
-       emsfc_lw = 1.
-               
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         ! Define new vertical grid
@@ -288,5 +312,9 @@
         call construct_cosp_lidarstats(cfg,Npoints,Ncolumns,vgrid%Nlvgrid,N_HYDRO,PARASOL_NREFL,stlidar)
         call construct_cosp_isccp(cfg,Npoints,Ncolumns,Nlevels,isccp)
+!! AI rajout
+        call construct_cosp_modis(cfg,Npoints,modis)
+!!
         call construct_cosp_misr(cfg,Npoints,misr)
+!        call construct_cosp_rttov(cfg,Npoints,Nchannels,rttov)
 
 !+++++++++++++ Open output files and define output files axis !+++++++++++++
@@ -306,11 +334,21 @@
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         print *, 'Calling simulator...'
-        call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,stradar,stlidar)
+!! AI 
+!        call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,stradar,stlidar)
+!#ifdef RTTOV
+!        call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
+!#else
+        call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
+!#endif
+!!
+
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
 !!!!!!!!!!!!!!!!!! Ecreture des sorties Cosp !!!!!!!!!!!!!!r!!!!!!:!!!!!
+
        print *, 'Calling write output'
         call cosp_output_write(Nlevlmdz, Npoints, Ncolumns, itap, dtime, freq_COSP, &
-                               cfg, gbx, vgrid, sglidar, stlidar, isccp)
+                               cfg, gbx, vgrid, sglidar, sgradar, stlidar, stradar, & 
+                               isccp, misr, modis)
 
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -326,4 +364,8 @@
         call free_cosp_isccp(isccp)
         call free_cosp_misr(misr)
+!! AI
+        call free_cosp_modis(modis)
+!        call free_cosp_rttov(rttov)
+!!
         call free_cosp_vgrid(vgrid)  
   
Index: LMDZ5/trunk/libf/phylmd/cosp/prec_scops.F
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/prec_scops.F	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/prec_scops.F	(revision 2428)
@@ -1,4 +1,6 @@
 ! (c) 2008, Lawrence Livermore National Security Limited Liability Corporation.
 ! All rights reserved.
+! $Revision: 23 $, $Date: 2011-03-31 15:41:37 +0200 (jeu. 31 mars 2011) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/llnl/prec_scops.f $
 ! 
 ! Redistribution and use in source and binary forms, with or without modification, are permitted 
@@ -45,7 +47,7 @@
                                         ! 1 -> LS precipitation
                                         ! 2 -> CONV precipitation
-					! 3 -> both
+                    ! 3 -> both
                                         !TOA to SURFACE!!!!!!!!!!!!!!!!!!
-					
+                    
       INTEGER flag_ls, flag_cv
       INTEGER frac_out_ls(npoints,ncol),frac_out_cv(npoints,ncol) !flag variables for 
@@ -56,31 +58,31 @@
  
       do ilev=1,nlev
-      do ibox=1,ncol
-        do j=1,npoints 
-        prec_frac(j,ibox,ilev) = 0
+        do ibox=1,ncol
+          do j=1,npoints 
+            prec_frac(j,ibox,ilev) = 0
+          enddo
         enddo
-      enddo
       enddo
       
       do j=1,npoints
        do ibox=1,ncol
-       frac_out_ls(j,ibox)=0
-       frac_out_cv(j,ibox)=0
-       flag_ls=0
-       flag_cv=0
+        frac_out_ls(j,ibox)=0
+        frac_out_cv(j,ibox)=0
+        flag_ls=0
+        flag_cv=0
         do ilev=1,nlev
-	 if (frac_out(j,ibox,ilev) .eq. 1) then 
-	  flag_ls=1
-	 endif
-	 if (frac_out(j,ibox,ilev) .eq. 2) then 
-	  flag_cv=1
-	 endif
-	enddo !loop over nlev
-	if (flag_ls .eq. 1) then
-	 frac_out_ls(j,ibox)=1
-	endif
-	if (flag_cv .eq. 1) then
-	 frac_out_cv(j,ibox)=1
-	endif
+          if (frac_out(j,ibox,ilev) .eq. 1) then 
+            flag_ls=1
+          endif
+          if (frac_out(j,ibox,ilev) .eq. 2) then 
+            flag_cv=1
+          endif
+        enddo !loop over nlev
+        if (flag_ls .eq. 1) then
+           frac_out_ls(j,ibox)=1
+        endif
+        if (flag_cv .eq. 1) then
+           frac_out_cv(j,ibox)=1
+        endif
        enddo  ! loop over ncol
       enddo ! loop over npoints
@@ -89,86 +91,86 @@
        do j=1,npoints
         flag_ls=0
-	flag_cv=0
-	
+        flag_cv=0
+    
         if (ls_p_rate(j,1) .gt. 0.) then 
-         do ibox=1,ncol ! possibility ONE
-          if (frac_out(j,ibox,1) .eq. 1) then 
-           prec_frac(j,ibox,1) = 1
-	   flag_ls=1
-	  endif
-	 enddo ! loop over ncol
-	 if (flag_ls .eq. 0) then ! possibility THREE
-	  do ibox=1,ncol
-	   if (frac_out(j,ibox,2) .eq. 1) then 
-	    prec_frac(j,ibox,1) = 1
-	    flag_ls=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_ls .eq. 0) then ! possibility Four
-	  do ibox=1,ncol
-	   if (frac_out_ls(j,ibox) .eq. 1) then 
-	    prec_frac(j,ibox,1) = 1
-	    flag_ls=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_ls .eq. 0) then ! possibility Five
-	  do ibox=1,ncol
-!	  prec_frac(j,1:ncol,1) = 1
-	  prec_frac(j,ibox,1) = 1
-	  enddo ! loop over ncol
-       	 endif
-	endif
+            do ibox=1,ncol ! possibility ONE
+                if (frac_out(j,ibox,1) .eq. 1) then 
+                    prec_frac(j,ibox,1) = 1
+                    flag_ls=1
+                endif
+            enddo ! loop over ncol
+            if (flag_ls .eq. 0) then ! possibility THREE
+                do ibox=1,ncol
+                    if (frac_out(j,ibox,2) .eq. 1) then 
+                        prec_frac(j,ibox,1) = 1
+                        flag_ls=1
+                    endif
+                enddo ! loop over ncol
+            endif
+        if (flag_ls .eq. 0) then ! possibility Four
+        do ibox=1,ncol
+        if (frac_out_ls(j,ibox) .eq. 1) then 
+            prec_frac(j,ibox,1) = 1
+            flag_ls=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_ls .eq. 0) then ! possibility Five
+        do ibox=1,ncol
+    !     prec_frac(j,1:ncol,1) = 1
+        prec_frac(j,ibox,1) = 1
+        enddo ! loop over ncol
+            endif
+        endif
        ! There is large scale precipitation
-	 
+     
         if (cv_p_rate(j,1) .gt. 0.) then 
          do ibox=1,ncol ! possibility ONE
           if (frac_out(j,ibox,1) .eq. 2) then 
            if (prec_frac(j,ibox,1) .eq. 0) then
-	    prec_frac(j,ibox,1) = 2
-	   else
-	    prec_frac(j,ibox,1) = 3
-	   endif
-	   flag_cv=1
-	  endif
-	 enddo ! loop over ncol
-	 if (flag_cv .eq. 0) then ! possibility THREE
-	  do ibox=1,ncol
-	   if (frac_out(j,ibox,2) .eq. 2) then 
-            if (prec_frac(j,ibox,1) .eq. 0) then
-	     prec_frac(j,ibox,1) = 2
-	    else
-	     prec_frac(j,ibox,1) = 3
-	    endif
-	    flag_cv=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_cv .eq. 0) then ! possibility Four
-	  do ibox=1,ncol
-	   if (frac_out_cv(j,ibox) .eq. 1) then 
-            if (prec_frac(j,ibox,1) .eq. 0) then
-	     prec_frac(j,ibox,1) = 2
-	    else
-	     prec_frac(j,ibox,1) = 3
-	    endif
-	    flag_cv=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_cv .eq. 0) then  ! possibility Five
-	  do ibox=1,cv_col
-            if (prec_frac(j,ibox,1) .eq. 0) then
-	     prec_frac(j,ibox,1) = 2
-	    else
-	     prec_frac(j,ibox,1) = 3
-	    endif 
-	  enddo !loop over cv_col
-       	 endif 
-	endif 
-       ! There is convective precipitation
-	
-       enddo ! loop over npoints
+        prec_frac(j,ibox,1) = 2
+       else
+        prec_frac(j,ibox,1) = 3
+       endif
+       flag_cv=1
+      endif
+        enddo ! loop over ncol
+        if (flag_cv .eq. 0) then ! possibility THREE
+        do ibox=1,ncol
+        if (frac_out(j,ibox,2) .eq. 2) then 
+                if (prec_frac(j,ibox,1) .eq. 0) then
+            prec_frac(j,ibox,1) = 2
+            else
+            prec_frac(j,ibox,1) = 3
+            endif
+            flag_cv=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_cv .eq. 0) then ! possibility Four
+        do ibox=1,ncol
+        if (frac_out_cv(j,ibox) .eq. 1) then 
+                if (prec_frac(j,ibox,1) .eq. 0) then
+            prec_frac(j,ibox,1) = 2
+            else
+            prec_frac(j,ibox,1) = 3
+            endif
+            flag_cv=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_cv .eq. 0) then  ! possibility Five
+        do ibox=1,cv_col
+                if (prec_frac(j,ibox,1) .eq. 0) then
+            prec_frac(j,ibox,1) = 2
+            else
+            prec_frac(j,ibox,1) = 3
+            endif 
+        enddo !loop over cv_col
+            endif 
+        endif 
+        ! There is convective precipitation
+        
+        enddo ! loop over npoints
 !      end of initializing the top layer
 
@@ -179,6 +181,6 @@
        do j=1,npoints
         flag_ls=0
-	flag_cv=0
-	
+        flag_cv=0
+    
         if (ls_p_rate(j,ilev) .gt. 0.) then 
          do ibox=1,ncol ! possibility ONE&TWO
@@ -187,31 +189,31 @@
      &       .or. (prec_frac(j,ibox,ilev-1) .eq. 3))) then 
            prec_frac(j,ibox,ilev) = 1
-	   flag_ls=1
+           flag_ls=1
           endif
-	 enddo ! loop over ncol
-	 if ((flag_ls .eq. 0) .and. (ilev .lt. nlev)) then ! possibility THREE
-	  do ibox=1,ncol
-	   if (frac_out(j,ibox,ilev+1) .eq. 1) then 
-	    prec_frac(j,ibox,ilev) = 1
-	    flag_ls=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_ls .eq. 0) then ! possibility Four
-	  do ibox=1,ncol
-	   if (frac_out_ls(j,ibox) .eq. 1) then 
-	    prec_frac(j,ibox,ilev) = 1
-	    flag_ls=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_ls .eq. 0) then ! possibility Five
-	  do ibox=1,ncol
-!	  prec_frac(j,1:ncol,ilev) = 1
-	  prec_frac(j,ibox,ilev) = 1
-	  enddo ! loop over ncol
-       	 endif
-	endif ! There is large scale precipitation
-	
+        enddo ! loop over ncol
+        if ((flag_ls .eq. 0) .and. (ilev .lt. nlev)) then ! possibility THREE
+        do ibox=1,ncol
+        if (frac_out(j,ibox,ilev+1) .eq. 1) then 
+            prec_frac(j,ibox,ilev) = 1
+            flag_ls=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_ls .eq. 0) then ! possibility Four
+        do ibox=1,ncol
+        if (frac_out_ls(j,ibox) .eq. 1) then 
+            prec_frac(j,ibox,ilev) = 1
+            flag_ls=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_ls .eq. 0) then ! possibility Five
+        do ibox=1,ncol
+!     prec_frac(j,1:ncol,ilev) = 1
+        prec_frac(j,ibox,ilev) = 1
+        enddo ! loop over ncol
+         endif
+      endif ! There is large scale precipitation
+    
         if (cv_p_rate(j,ilev) .gt. 0.) then 
          do ibox=1,ncol ! possibility ONE&TWO
@@ -220,48 +222,48 @@
      &       .or. (prec_frac(j,ibox,ilev-1) .eq. 3))) then 
             if (prec_frac(j,ibox,ilev) .eq. 0) then
-	     prec_frac(j,ibox,ilev) = 2
-	    else
-	     prec_frac(j,ibox,ilev) = 3
-	    endif 
-	   flag_cv=1
-          endif
-	 enddo ! loop over ncol
-	 if ((flag_cv .eq. 0) .and. (ilev .lt. nlev)) then ! possibility THREE
-	  do ibox=1,ncol
-	   if (frac_out(j,ibox,ilev+1) .eq. 2) then 
-            if (prec_frac(j,ibox,ilev) .eq. 0) then
-	     prec_frac(j,ibox,ilev) = 2
-	    else
-	     prec_frac(j,ibox,ilev) = 3
-	    endif
-	    flag_cv=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_cv .eq. 0) then ! possibility Four
-	  do ibox=1,ncol
-	   if (frac_out_cv(j,ibox) .eq. 1) then 
-            if (prec_frac(j,ibox,ilev) .eq. 0) then
-	     prec_frac(j,ibox,ilev) = 2
-	    else
-	     prec_frac(j,ibox,ilev) = 3
-	    endif
-	    flag_cv=1
-	   endif
-	  enddo ! loop over ncol
-	 endif
-	 if (flag_cv .eq. 0) then  ! possibility Five 
-	  do ibox=1,cv_col
-            if (prec_frac(j,ibox,ilev) .eq. 0) then
-	     prec_frac(j,ibox,ilev) = 2
-	    else
-	     prec_frac(j,ibox,ilev) = 3
-	    endif 
-	  enddo !loop over cv_col 
-       	 endif 
-	endif ! There is convective precipitation
-
-       enddo ! loop over npoints
-      enddo ! loop over nlev
+         prec_frac(j,ibox,ilev) = 2
+        else
+         prec_frac(j,ibox,ilev) = 3
+        endif 
+        flag_cv=1
+        endif
+       enddo ! loop over ncol
+        if ((flag_cv .eq. 0) .and. (ilev .lt. nlev)) then ! possibility THREE
+        do ibox=1,ncol
+        if (frac_out(j,ibox,ilev+1) .eq. 2) then 
+                if (prec_frac(j,ibox,ilev) .eq. 0) then
+            prec_frac(j,ibox,ilev) = 2
+            else
+            prec_frac(j,ibox,ilev) = 3
+            endif
+            flag_cv=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_cv .eq. 0) then ! possibility Four
+        do ibox=1,ncol
+        if (frac_out_cv(j,ibox) .eq. 1) then 
+                if (prec_frac(j,ibox,ilev) .eq. 0) then
+            prec_frac(j,ibox,ilev) = 2
+            else
+            prec_frac(j,ibox,ilev) = 3
+            endif
+            flag_cv=1
+        endif
+        enddo ! loop over ncol
+        endif
+        if (flag_cv .eq. 0) then  ! possibility Five 
+        do ibox=1,cv_col
+                if (prec_frac(j,ibox,ilev) .eq. 0) then
+            prec_frac(j,ibox,ilev) = 2
+            else
+            prec_frac(j,ibox,ilev) = 3
+            endif 
+        enddo !loop over cv_col 
+            endif 
+        endif ! There is convective precipitation
+    
+        enddo ! loop over npoints
+        enddo ! loop over nlev
 
       end
